/*--------------------------------------------------------------------
 * $Id: wcloud3d.h,v 1.8 2004/03/04 17:23:01 pa2h Exp $
 * 
 * This file is part of libRadtran.
 * Copyright (c) 1997-2001 by Arve Kylling and Bernhard Mayer.
 * 
 * ######### Contact info: http://www.libradtran.org #########
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License   
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.        
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of  
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the   
 * GNU General Public License for more details.                    
 * 
 * You should have received a copy of the GNU General Public License          
 * along with this program; if not, write to the Free Software                
 * Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *--------------------------------------------------------------------*/

#ifndef __wcloud3d_h
#define __wcloud3d_h

#if defined (__cplusplus)
extern "C" {
#endif
  
  
#include "mystic.h"

/* prototypes */
int read_3D_cloud (char *filename, 
		   int *Nx, int *Ny, int *Nz,
		   double *delX, double *delY,
		   double **zcld3D, float ****kcld3d, int **threed,
		   float ****gcld3d, int *gspec,
		   float ****wcld3d, int *wspec,
		   int quiet);

int read_2D_albedo (char *filename, 
		    int *Nx, int *Ny,
		    double *delX, double *delY,
		    double ***albedo,
		    int quiet);

int read_2D_rpv (char *filename, 
		 char **rpv_labels, int rpv_nlabels,
		 int *Nx, int *Ny,
		 double *delX, double *delY,
		 char ***rpv, int **rpv_count,
		 int quiet);

int read_2D_elevation (char *filename, 
		       int *Nx, int *Ny,
		       double *delX, double *delY,
		       double ***elevation,
		       int quiet);

int read_2D_sample (char *filename, 
		    int *Nx, int *Ny, int *Nz,
		    double *delX, double *delY, double **z,
		    double **theta, double **phi, double **alpha, int *nrad,
		    int aziconv,
		    int quiet);


/* The following functions probably don't belong here but  */
/* rather to mc.c; in a future version, there will be a    */
/* better distinction between mc.c and wcloud3d.c and than */ 
/* these functions will be gone.                           */

void init_direction (double sinsza, double cossza, double sinphi, double cosphi, 
		     direction *dir);

void hitflag (direction *dir);


#if defined (__cplusplus)
}
#endif

#endif






